/* --------------------------------------------------------------  */
/* (C)Copyright 2001,2007,                                         */
/* International Business Machines Corporation,                    */
/* Sony Computer Entertainment, Incorporated,                      */
/* Toshiba Corporation,                                            */
/*                                                                 */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
#ifndef _LIB_LARGE_MATRIX_H_
#define _LIB_LARGE_MATRIX_H_ 1

#include <spu_intrinsics.h>

#ifndef BLOCK_SIZE
#define BLOCK_SIZE 16 
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern int index_max_abs_col (int n, float* m, int col, int stride);
extern int index_max_abs_vec (int n, float* dx);
extern int lu2_decomp (int m, int n, float* a, int lda, int* ipiv);
extern int lu3_decomp (int m, int n, float* a, int lda, int* ipiv);

extern void madd_matrix_matrix (int m, int p, int n, float a[], int lda, 
                                float b[], int ldb, float c[], int ldc);


extern void madd_number_vector (int n, float da, float *dx, float *dy);

extern void madd_vector_vector (int m, int n, float *col, int c_stride, 
                                float *row, float * a, int a_stride);

extern void nmsub_matrix_matrix (int m, int p, int n, float a[], int lda, 
                                 float b[], int ldb, float c[], int ldc);

extern void nmsub_number_vector (int n, float da, float *dx, float *dy);


extern void nmsub_vector_vector (int m, int n, float *col, int c_stride, 
                         float *row, float * a, int a_stride);

extern void scale_matrix_col (int n, float scale_factor, float *m, 
                              int col, int stride);

extern void scale_vector (int n, float da, float *dx);

extern int solve_linear_system_1 (int n, float* a, int lda, int* ipiv, float* b);


extern void solve_unit_lower (int m, int n, float * a, int lda, float* b, int ldb);
extern void solve_upper (int m, int n, float * a, int lda, float* b, int ldb);
extern void solve_unit_lower_1 (int m, float * a, int lda, float* b);
extern void solve_upper_1(int m, float * a, int lda, float* b);

extern void swap_matrix_rows (int n, float * a, int lda, int k1, int k2, int* ipiv);
extern void swap_vectors (int n, float * sx, float *sy);
extern void transpose_matrix (int m, int n, float* a, int lda, float* b, int ldb);

#ifdef __cplusplus
}
#endif

#endif /* _LIB_LARGE_MATRIX_H_ */
